/*
    Copyright (C) 2004, Wolfgang Hottgenroth

    This file is part of smmapdfw.

    smmapdfw is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  

    smmapdfw is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details. 

    You should have received a copy of the GNU General Public License
    along with smmapdfw. If not, write to the Free Software Foundation, 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef _CONFIG_H_
#define _CONFIG_H_




struct config_item_s {
  char *name;
  char *value;
  struct config_item_s *next;
};

typedef struct config_item_s config_item_t;

struct config_section_s {
  char *name;
  config_item_t *item;
  struct config_section_s *next;
};

typedef struct config_section_s config_section_t;
typedef config_section_t cfg_t;
typedef config_item_t cfgl_t;


config_section_t *readcfg(char *cfgfile);
void freecfg(config_section_t *cfg);
char *findcfg(config_section_t *cfg, char *section, char *name);
char *findcfgx(config_section_t *cfg, char *section, char *name, char *default_value);
config_item_t *findcfgsection(config_section_t *cfg, char *section);
extern char *findcfgl(config_item_t *cfg, char *name);
extern char *findcfglx(config_item_t *cfg, char *name, char *default_value);


#endif /* _CONFIG_H_ */  

  
