/*
    Copyright (C) 2004, Wolfgang Hottgenroth

    This file is part of smmapdfw.

    smmapdfw is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  

    smmapdfw is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details. 

    You should have received a copy of the GNU General Public License
    along with smmapdfw. If not, write to the Free Software Foundation, 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#if HAVE_CONFIG_H
# include "config.h"
#endif


#if HAVE_STRING_H
#include <string.h>
#endif

#include "cfg.h"

char *findcfgl(config_item_t *cfg, char *name) {
  config_item_t *ci;

  for (ci = cfg; ci != NULL; ci = ci->next)
    if (0 == strcmp(name, ci->name))
      return ci->value;
  return NULL;
}

char *findcfglx(config_item_t *cfg, char *name, char *default_value) {
  char *r = findcfgl(cfg, name);
  return (NULL != r) ? r : default_value;
}

