/*
    Copyright (C) 2004, Wolfgang Hottgenroth

    This file is part of smmapdfw.

    smmapdfw is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  

    smmapdfw is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details. 

    You should have received a copy of the GNU General Public License
    along with smmapdfw. If not, write to the Free Software Foundation, 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/



#ifndef _DNS_H_
#define _DNS_H_

struct mx_rdata_s {
  int type;
  int preference;
  char *exchange;
};

typedef struct mx_rdata_s mx_rdata_t;

struct cname_rdata_s {
  int type;
  char *cname;
};

typedef struct cname_rdata_s cname_rdata_t;

struct a_rdata_s {
  int type;
  unsigned int address;
};

typedef struct a_rdata_s a_rdata_t;

struct rdata_s {
  int type;
  union {
    mx_rdata_t mx;
    a_rdata_t a;
    cname_rdata_t cname;
  } data;
};

typedef struct rdata_s rdata_t;


void free_rrs(void **resp);
mx_rdata_t** get_mx_rrs(char *domain);
mx_rdata_t** get_best_mx_rrs(char *domain);
a_rdata_t** get_a_rrs(char *domain);
cname_rdata_t** get_cname_rrs(char *domain);



#endif /* _DNS_H_ */  

  
