/*
    Copyright (C) 2004, Wolfgang Hottgenroth

    This file is part of smmapdfw.

    smmapdfw is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  

    smmapdfw is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details. 

    You should have received a copy of the GNU General Public License
    along with smmapdfw. If not, write to the Free Software Foundation, 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef _STATS_H_
#define _STATS_H_

#include "smmapd.h"

#ifdef _STATS_C_
char *stat_cnt_names[] = {
  "accepted", 
  "failed",
  "Running networker threads",
  "Failed to start, networker threads",
  "returned OK",
  "returned TEMP_NOK",
  "returned PERM_NOK",
  "returned NOT_FOUND_NOK",
  "returned illegal input",
  "returned unknown class",
  "returned TIMEOUT_NOK",
  "returned netstring unparsable",
};
#endif /* _STATS_C_ */


#define STAT_CNT_ACCEPTED 1
#define STAT_CNT_FAILED   2
#define STAT_CNT_NETWORKER_THREADS 3
#define STAT_CNT_NETWORKER_THREADS_FAILED 4

#define STAT_CNT_OFFSET 4
#define STAT_CNT_MAXNUM STAT_CNT_OFFSET + SMM_MAX_NUM


void initStatCounter();
unsigned int getStatCounter(int cnt_idx);
void incStatCounter(int cnt_idx);
void decStatCounter(int cnt_idx);

#endif /* _STATS_H_ */
