/*
    Copyright (C) 2004, Wolfgang Hottgenroth

    This file is part of smmapdfw.

    smmapdfw is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  

    smmapdfw is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details. 

    You should have received a copy of the GNU General Public License
    along with smmapdfw. If not, write to the Free Software Foundation, 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/



#ifndef _CONTAINERS_H_
#define _CONTAINERS_H_

#define _SMMAPD_
#include "containers_public.h"

struct classes_s {
  class_descriptor_t *descr;
  int id;
  void *handle;
  struct classes_s *next;
};

typedef struct classes_s classes_t;

struct worker_handle_s {
  int id;
  void *handle;
  struct worker_handle_s *next;
};

typedef struct worker_handle_s worker_handle_t;

struct container_handle_s {
  worker_handle_t worker_handle_root;
};

typedef struct container_handle_s container_handle_t;

int containers_setup(container_handle_t **ch);
int containers_destroy(container_handle_t *ch);
int containers_dispatcher(container_handle_t *ch, char *input, char *output);

int register_all();


#endif /* _CONTAINERS_H_ */  

  
