import socket
import time
from threading import Thread, activeCount


class NetStringError(ValueError): pass

def NetStringDecode(s):
    try:
        length, data = s.split(':', 1)
    except ValueError:
        raise NetStringError, "Separator not found"
    try:
        length = int(length)
    except ValueError:
        raise NetStringError, "Can not read length"
    if len(data) != length+1:
        raise NetStringError, "Data has unexpected length"
    if data[-1] != ',':
        raise NetStringError, "End-delimiter not found"
    return data[:-1]

def NetStringEncode(s):
    return str(len(s)) + ":" + s + ","


class Connector (Thread):
    def __init__(self, config, details):
        Thread.__init__(self)
        self.config = config
        self.host = self.config.get('Global', 'Host')
        self.port = int(self.config.get('Global', 'Port'))
        self.klass = self.__class__.__name__
        self.details = details

    def connect(self):
        self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.sock.connect((self.host, self.port))
        

    def query(self, request):
        nets_request = NetStringEncode(self.klass + ' ' + request)

        print(self.getName() + " REQUEST: " + nets_request)
        self.sock.sendall(nets_request)

        nets_response = self.sock.recv(8192)
        print(self.getName() + " NETS_RESPONSE: " + nets_response)
        response = NetStringDecode(nets_response)
        print(self.getName() + " RESPONSE: " + response)

        return response

    def close(self):
        self.sock.close()
        
        
    def execute(self):
        raise NotImplementedError

    def run(self):
        return self.execute()


def threadedExecute(config, klass, numOfThreads, details):
    threads = []

    while (1):
        if activeCount() < numOfThreads:
            t = klass(config, details)
            t.start()
        else:
            time.sleep(1)
        
    
